﻿using System;
using System.ServiceModel;
using Services;
using Contracts;
using System.ServiceModel.Description;
using System.ServiceModel.Channels;

namespace Hosting
{
    /// <summary>
    /// Host，承载服务
    /// </summary>
    class Program
    {

        static void Main(string[] args)
        {
            #region 采用代码方式实现对契约的绑定
            Uri baseAddress = new Uri("http://127.0.0.1:9999/");
            using (ServiceHost host = new ServiceHost(typeof(CalculatorService), baseAddress))
            {
                //使用指定的协定、绑定和终结点地址将服务终结点添加到承载服务中
                host.AddServiceEndpoint(typeof(ICalculator), new WSHttpBinding(), "CalculatorService");

                #region Behavior
                
                ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
                behavior.HttpGetEnabled = true;
                behavior.HttpGetUrl = new Uri("http://127.0.0.1:9999/CalculatorService/metadata");
                host.Description.Behaviors.Add(behavior);
                #endregion

                host.Opened += delegate
                {
                    Console.WriteLine("CalculaorService已经启动，按任意键终止服务！");
                };

                host.Open();
                Console.Read();
            }
            #endregion

            #region 在配置文件中已经定义了终结点，服务寄宿代码
            ////如果使用配置文件，需要加载项目的配置文件
            //using (ServiceHost host = new ServiceHost(typeof(CalculatorService)))
            //{
            //    host.Opened += delegate
            //     {
            //         Console.WriteLine("CalculaorService已经启动，按任意键终止服务！");
            //     };

            //    host.Open();
            //    Console.Read();
            //}
            #endregion
        }


    }
}
